MARTe2-core - User story #103

MARTe-EX-D-1.2.1: The framework shall offer multi-threading support to application developers.
29.05.2015 14:18 - André Neto

Status: Closed Start date:
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 8.00 hours
Target version: 0.2 Spent time: 0.00 hour
Git branch (link): SVN commit
(link/?p=rev):
Git merge to develop
(link):
Description
See #160

Implement requirement MARTe-EX-D-1.2.1 based on the original MARTe implementation

Note: One of the key features of MARTEe is the possibility of executing real-time multi-threading applications.

Source code files modified

e Source/Core/L0Portability/ThreadsDatabase.h
Source/Core/LOPortability/ThreadsDatabase.cpp
Source/Core/L0Portability/Threads.h
Source/Core/L0Portability/Threads.cpp
Source/Core/LOPortability/OperatingSystem/Linux/ThreadsOS.h
Source/Core/L0Portability/OperatingSystem/Windows/ThreadsOS.h
Source/Core/L0Portability/ThreadInformation.h
Source/Core/L0Portability/ TimeoutType.h

Architecture & design review

Date of the review: 08/06/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support class and does not
require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review

Date of the review: 18/06/2015
Person who did the review: lvan Herrero
Result of review: PASS

List of non-conformities: N/A

Unit test review

Date of the review: 01/07/2015
Person who did the review: lvan Herrero
Result of coverage tests review: FAIL
Result of functional tests review: FAIL
Result of review: FAIL

List of non-conformities:

Classes ThreadsDatabase and Threads reviewed on #109.

The classes TimeoutType and ThreadInformation lack unit tests.

Associated revisions

Revision 67764feb - 11.06.2015 07:56 - Giuseppe Ferro

Implemented threads functionalities described in redmine #103 #104 #112 #107 #108 #111 #105 #106 #110 #109

Revision 9bf99966 - 15.06.2015 14:53 - Giuseppe Ferro

Used references in operators of TimeoutType.h

Added the initialization of the internal semaphore in all ThreadInformation constructors.

#103

Revision 54acac5a - 15.06.2015 16:31 - Giuseppe Ferro

Formatted TimeoutType with new templates.
#103

Revision 8c12¢7dd - 15.06.2015 16:35 - Giuseppe Ferro
Added const to the input parameters of the functions when necessary.

#103

Revision f048da13 - 17.06.2015 12:10 - Giuseppe Ferro

Moved THREADS_DEFAULT_STACKSIZE in GeneralDefinitionsOS.h.

Formatted code with new templates.
Fixed errors accordingly with the revision.
#109 #110 #106 #105 #111 #108 #107 #112 #113 #104 #103

Revision 5d7c7a45 - 18.06.2015 08:09 - Giuseppe Ferro

Fixed errors accordingly with revision.
#103 #104 #112 #107 #108 #111 #105 #106

Revision 9b815252 - 18.06.2015 14:42 - Giuseppe Ferro

Fixed minor issues
#103

Revision 56f896af - 23.06.2015 16:59 - Giuseppe Ferro

Added Threads and ThreadsDatabase tests.
#110 #123 #103 #104 #112 #107 #108 #111 #106 #105 #109 #113

Revision a1ee0477 - 25.06.2015 13:37 - Giuseppe Ferro

Added Threads unit tests.
Renamed previous tests because they are integration tests.
#110 #123 #103 #104 #112 #107 #108 #111 #106 #105 #109 #113

Revision 82e5a66a - 02.07.2015 12:19 - Giuseppe Ferro

Fixed minor issues.
Made private the ThreadsDatabase members.
#103

Revision 49629537 - 02.07.2015 12:21 - Giuseppe Ferro

Added Threads Tests.
#103
Revision cb3c4fa0 - 02.07.2015 15:44 - Giuseppe Ferro

Minor changes
#103

Revision d2209ae1 - 27.07.2015 14:59 - Giuseppe Ferro
Windows porting for Threads.

#103

History

#1 - 03.06.2015 10:18 - Riccardo Vitelli

- Target version changed from Backlog to 0.1
- Start date deleted (29.05.2015)

- Estimated time set to 8.00 h

#2 - 08.06.2015 09:25 - Riccardo Vitelli

- Status changed from New to Arch: Rev

#3 - 08.06.2015 09:26 - Riccardo Vitelli

- Assignee set to André Neto

#4 - 08.06.2015 13:13 - André Neto
- Description updated

#5 - 08.06.2015 17:53 - Riccardo Vitelli
- Status changed from Arch: Rev to Code: Impl

#6 - 08.06.2015 17:54 - Riccardo Vitelli

- Assignee changed from André Neto to Giuseppe Ferro

#7 - 12.06.2015 10:29 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#8 - 12.06.2015 11:16 - Riccardo Vitelli

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#9 - 16.06.2015 17:13 - lvan Herrero
- Description updated

#10 - 16.06.2015 17:25 - Ivan Herrero
- Description updated

#11 - 17.06.2015 12:55 - Ivan Herrero
- Description updated

#12 - 17.06.2015 16:55 - Ivan Herrero
- Description updated

#13 - 18.06.2015 09:48 - Ivan Herrero

- Assignee changed from Ivan Herrero to Giuseppe Ferro

#14 - 18.06.2015 15:38 - Ivan Herrero

- Description updated

#15 - 18.06.2015 17:10 - Ivan Herrero
- Description updated

- Assignee deleted (Giuseppe Ferro)
#16 - 18.06.2015 17:10 - Ivan Herrero
- Status changed from Code: Rev to Unit: Impl

#17 - 18.06.2015 18:18 - lvan Herrero

Code and documentation review passed. Unit testing implementation pending.

#18 - 25.06.2015 17:22 - Riccardo Vitelli
- Status changed from Unit: Impl to Unit: Rev

#19 - 01.07.2015 16:49 - Ivan Herrero
- Description updated

Unit test review made on revision 8b64124 [FAIL].

Note: It is currently being refactored.

#20 - 01.07.2015 17:59 - Riccardo Vitelli
- Status changed from Unit: Rev to Unit: Impl

#21 - 02.07.2015 15:49 - Riccardo Vitelli
- Status changed from Unit: Impl to Unit: Rev

#22 - 02.07.2015 18:06 - Riccardo Vitelli

- Target version changed from 0.1 to 0.2

#23 - 08.07.2015 12:15 - Ivan Herrero

- Assignee set to Ivan Herrero

#24 - 15.07.2015 15:30 - Ilvan Herrero

- Description updated

A unit test review has been done on revision 6072de0 with a result of "FAIL".

#25 - 15.07.2015 15:30 - Ivan Herrero
- Status changed from Unit: Rev to Unit: Impl

#26 - 15.07.2015 15:31 - Ivan Herrero

- Assignee deleted (Ilvan Herrero)

#27 - 15.07.2015 18:02 - Llorenc Capella

- Assignee set to Llorenc Capella

#28 - 16.07.2015 09:28 - Riccardo Vitelli
- Status changed from Unit: Impl to Code: Impl

#29 - 16.07.2015 09:28 - Riccardo Vitelli
- Assignee deleted (Llorenc Capella)

#30 - 29.07.2015 15:14 - Riccardo Vitelli

- Description updated

#31 - 29.07.2015 15:15 - Riccardo Vitelli
- Status changed from Code: Impl to Closed
